import { Injectable } from '@angular/core';
import { map } from "rxjs/operators";
import { HttpClient,HttpHeaders } from "@angular/common/http";
import { environment } from "../../environments/environment";

@Injectable({
  providedIn: 'root'
})
export class ErpService {

  public base_url: any;
  
  constructor(public http:HttpClient) { 
   this.base_url = environment.baseUrl;
  }

  getRequiredInitialData(){
    return this.http.get<any>( this.base_url+'ErpController/getRequiredInitialData')
    .pipe(  
      map(res => {
        return res;
      })
    );
  }
  
  getColorData(data) {
    return this.http.post<any>( this.base_url+'ErpController/getColorData', data)
    .pipe(  
      map(res => {
        return res;
      })
      );
  }

  getAutoGeneratedErpNumber(){
    return this.http.get<any>( this.base_url+'ErpController/getAutoGeneratedErpNumber')
    .pipe(  
      map(res => {
        return res;
      })
    );
  }
  
  getErpList() {
    return this.http.get<any>( this.base_url+'ErpController/getErpList')
  .pipe(  
    map(res => {
      return res;
    })
    );
  }

  getFilteredErpListData(data) {
    return this.http.post<any>( this.base_url+'ErpController/getFilteredErpListData', data)
  .pipe(  
    map(res => {
      return res;
    })
    );
  }

  addorEditErp(data){
    return this.http.post<any>( this.base_url+'ErpController/addorEditErp', data)
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  getErpInformaton(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getErpInformaton', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  addorUpdateDeliverySchedule(data){
    return this.http.post<any>( this.base_url+'ErpController/addorUpdateDeliverySchedule', data)
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  getDeliverySchedules(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getDeliverySchedules', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  addorEditTopMaterialRequirement(data){
    return this.http.post<any>( this.base_url+'ErpController/addorEditTopMaterialRequirement', data)
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  addorEditBottomMaterialRequirement(data){
    return this.http.post<any>( this.base_url+'ErpController/addorEditBottomMaterialRequirement', data)
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

 
  getTopMaterialRequirements(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getTopMaterialRequirements', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }
  
  getBottomMaterialRequirements(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getBottomMaterialRequirements', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  getTrimRequirements(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getTrimRequirements', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  getFabricRequirements(erp_id){
    return this.http.post<any>( this.base_url+'ErpController/getFabricRequirements', {'erp_id':erp_id})
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

  addorUpdateRequirementLog(data){
    return this.http.post<any>( this.base_url+'ErpController/addorUpdateRequirementLog', data)
    .pipe(  
      map(res => {
        return res;
      })
    );
  }

}
